diff -uNra a/drivers/dahdi/dahdi-sysfs.c b/drivers/dahdi/dahdi-sysfs.c
--- a/drivers/dahdi/dahdi-sysfs.c	2025-05-29 14:55:42.519818320 +0800
+++ b/drivers/dahdi/dahdi-sysfs.c	2025-05-29 15:10:13.360627557 +0800
@@ -42,12 +42,12 @@
 MODULE_PARM_DESC(tools_rootdir,
 		"root directory of all tools paths (default /)");
 
-static int span_match(struct device *dev, struct device_driver *driver)
+static int span_match(struct device *dev, const struct device_driver *driver)
 {
 	return 1;
 }
 
-static inline struct dahdi_span *dev_to_span(struct device *dev)
+static inline struct dahdi_span *dev_to_span(const struct device *dev)
 {
 	return dev_get_drvdata(dev);
 }
@@ -461,7 +461,7 @@
 	unsigned int clean_chardev:1;
 } should_cleanup;
 
-static inline struct dahdi_device *to_ddev(struct device *dev)
+static inline struct dahdi_device *to_ddev(const struct device *dev)
 {
 	return container_of(dev, struct dahdi_device, dev);
 }
diff -uNra a/drivers/dahdi/dahdi-sysfs-chan.c b/drivers/dahdi/dahdi-sysfs-chan.c
--- a/drivers/dahdi/dahdi-sysfs-chan.c	2025-05-29 15:01:13.428162080 +0800
+++ b/drivers/dahdi/dahdi-sysfs-chan.c	2025-05-29 15:11:21.464680531 +0800
@@ -218,7 +218,7 @@
 	chan_dbg(DEVICES, chan, "SYSFS\n");
 }
 
-static int chan_match(struct device *dev, struct device_driver *driver)
+static int chan_match(struct device *dev, const struct device_driver *driver)
 {
 	struct dahdi_chan *chan;
 
diff -uNra a/drivers/dahdi/xpp/xbus-sysfs.c b/drivers/dahdi/xpp/xbus-sysfs.c
--- a/drivers/dahdi/xpp/xbus-sysfs.c	2025-05-29 14:55:42.555818341 +0800
+++ b/drivers/dahdi/xpp/xbus-sysfs.c	2025-05-29 14:58:11.155974226 +0800
@@ -400,7 +400,7 @@
 ATTRIBUTE_GROUPS(xbus_dev);
 #endif
 
-static int astribank_match(struct device *dev, struct device_driver *driver)
+static int astribank_match(struct device *dev, const struct device_driver *driver)
 {
 	DBG(DEVICES, "SYSFS MATCH: dev->bus_id = %s, driver->name = %s\n",
 	    dev_name(dev), driver->name);
@@ -802,7 +802,7 @@
 	return len;
 }
 
-static int xpd_match(struct device *dev, struct device_driver *driver)
+static int xpd_match(struct device *dev, const struct device_driver *driver)
 {
 	struct xpd_driver *xpd_driver;
 	xpd_t *xpd;
